{ Star v1.4 a system generator by Aina Rasolomalala (c) 06-1997 }

program generator;
{$M $4000,0,0 }
uses dos,crt;

const max_unusual= 30;
type table=array[1..20] of string;
     table_num=array[1..20] of integer;
     table_real=array[1..20] of real;
     table_1=array[1..2] of integer;
     table_2=array[1..2] of real;
     table_3=array[1..18] of word;
     table_4=array[1..12] of word;
     table_index=array[1..4] of real;
     table_10=array[1..50] of string;
     table_bool=array[1..max_unusual] of boolean;
     star_record = record
                     Id : word;
                     class,type_spec,planet_nbr: table_1;
                     luminosity,mass_star: table_2;
                     age,companion_dist  : real;
                     astral_orbit: table_real;
                     star_nbr       : shortint;
                     pln_id : table_3;
                    end;
     planet_record= record
                     Id,sun_id : word;
                     moon_id : table_4;
                     atmos_type,world_type,water_type,hydrography :integer;
                     atmos,temp_avg,axial_tilt,ast_width,satellites:integer;
                     orbit_period,rotation_period,day_temp,night_temp:longint;
                     density,gravity,mass,diametre,pressure:real;
                     oxygene_taux,eccentricity,escape_velocity: real;
                     orbit_radius: real;
                     mine_ress: table_num;
                     snowball,icy_core,resonance,water_tainted: boolean;
                     unusual: table_bool;
                    end;
var atmos_genre,world_genre,water_genre,atmos_comp,class_spec:table;
    unusual_genre:table_10;
    day_table,night_table,day_max,night_max,belt_width:table_real;
    oxygene_table,mine_k:table_num;
    gaia:boolean;
    
procedure initialisation;
   begin
       class_spec[1]:='A';
       class_spec[2]:='M';
       class_spec[3]:='F';
       class_spec[4]:='G';
       class_spec[5]:='K';
       class_spec[6]:='M';
       class_spec[7]:='F';
       class_spec[8]:='Primary Star Characteristics';
       class_spec[9]:='Companion Star Characteristics';
       
       atmos_genre[1]:='Massive  ';
       atmos_genre[2]:='Dense    ';
       atmos_genre[3]:='Standard ';
       atmos_genre[4]:='Thin     ';
       atmos_genre[5]:='Very thin';
       atmos_genre[6]:='Vacuum   ';

       world_genre[1]:='Ice Ball     ';
       world_genre[2]:='Rock         ';
       world_genre[3]:='Gas Giant    ';
       world_genre[4]:='Hot house    ';
       world_genre[5]:='Failed Core  ';
       world_genre[6]:='Asteroid Belt';
       world_genre[7]:='Chunk        ';
       world_genre[8]:='Arid         ';
       world_genre[9]:='Steppe        ';
       world_genre[10]:='Terran       ';
       world_genre[11]:='Jungle       ';
       world_genre[12]:='Ocean        ';
       world_genre[13]:='Desert       ';
       world_genre[14]:='Glacier      ';
       world_genre[15]:='Nickel-Iron  ';
       world_genre[16]:='Stony        ';
       world_genre[17]:='Carbonaceous ';
       world_genre[18]:='Icy          ';
       world_genre[19]:='Ring         ';

       water_genre[1]:='None';
       water_genre[2]:='Rare Ice';
       water_genre[3]:='Ice ';
       water_genre[4]:='Crystals';
       water_genre[5]:='Oceans';
       water_genre[6]:='Ice Sheets';

       atmos_comp[1]:='None';
       atmos_comp[2]:='Nitrogen/Oxygen';
       atmos_comp[3]:='Carbon Dioxyde';
       atmos_comp[4]:='Nitrogen';
       atmos_comp[5]:='Chlorine';
       atmos_comp[6]:='Hydrogen/Helium';
       atmos_comp[7]:='Ammonia';
       atmos_comp[8]:='Methane';
       atmos_comp[9]:='Flourine';
       atmos_comp[10]:='Exotic';

       oxygene_table[1]:=5;
       oxygene_table[2]:=10;
       oxygene_table[3]:=12;
       oxygene_table[4]:=14;
       oxygene_table[5]:=16;
       oxygene_table[6]:=18;
       oxygene_table[7]:=19;
       oxygene_table[8]:=20;
       oxygene_table[9]:=22;
       oxygene_table[10]:=24;
       oxygene_table[11]:=26;

       belt_width[1]:=0.01;
       belt_width[2]:=0.05;
       belt_width[3]:=0.1;
       belt_width[4]:=0.1;
       belt_width[5]:=0.5;
       belt_width[6]:=0.5;
       belt_width[7]:=1;
       belt_width[8]:=1.5;
       belt_width[9]:=2;
       belt_width[10]:=5;
       belt_width[11]:=10;

       day_table[1]:=0.2;
       day_table[2]:=0.4;
       day_table[3]:=0.5;
       day_table[4]:=0.6;
       day_table[5]:=0.8;
       day_table[6]:=1;

       day_max[1]:=5;
       day_max[2]:=4;
       day_max[3]:=2.5;
       day_max[4]:=1.5;
       day_max[5]:=0.8;
       day_max[6]:=0.1;

       night_table[1]:=0.2;
       night_table[2]:=0.5;
       night_table[3]:=1;
       night_table[4]:=3;
       night_table[5]:=8;
       night_table[6]:=20;

       night_max[1]:=0.05;
       night_max[2]:=0.1;
       night_max[3]:=0.15;
       night_max[4]:=0.3;
       night_max[5]:=0.5;
       night_max[6]:=0.8;

       unusual_genre[1]:='Extreme Vulcanism';
       unusual_genre[2]:='Atmospheric Contaminants';
       unusual_genre[3]:='Meteors Storms';
       unusual_genre[4]:='High Radiation Level';
       unusual_genre[5]:='Violent Storms';
       unusual_genre[6]:='Microbes';
       unusual_genre[7]:='Orbital Conjunction';
       unusual_genre[8]:='Rugged Terrain';
       unusual_genre[9]:='Retrograde Rotation';
       unusual_genre[10]:='Unstable Climate';
       unusual_genre[11]:='Orbital Eccentricity';
       unusual_genre[12]:='Unstable World';
       unusual_genre[13]:='Strong Magnetic Field';
       unusual_genre[14]:='Cloud Cover';
       unusual_genre[15]:='No Axial Tilt';
       unusual_genre[16]:='High Tides';
       unusual_genre[17]:='Tidal Lock';
       unusual_genre[18]:='Extreme Axial Tilt';
       unusual_genre[19]:='Native Intelligent Lifeforms';
       unusual_genre[20]:='Native Semi-Intelligent Lifeforms';
       unusual_genre[21]:='High Humidity';
       unusual_genre[22]:='Low Humidity';

       mine_k[1]:=70;
       mine_k[2]:=40;
       mine_k[3]:=10;
       mine_k[4]:=30;
       mine_k[5]:=10;
   end;

{ ***************************************
  de is a dice roll function
  de(6,4) is like throwing 4d6
  ***************************************}

function de(face,nombre:integer):integer;
   var res,i:integer;
   begin
     de:=0;
     res:=0;
     for i:=1 to nombre do
	res:=random(face)+res+1;
     de:=res;
   end;

{ ------------ returns the world type (res) ---------------}

procedure world_calcul(var atmos,res:integer;inz,outz,orb,diametre:real;icy,
       snow:boolean);
      var x:integer;
    begin
      if (atmos=6) and (not icy) then res:=2
	else
	    if icy and (atmos>2) then res:=1
		 else
		  begin
		   if atmos=5 then res:=2;
		   if atmos=4 then res:=13;
		   if atmos<4 then
			 if orb<inz then begin
					   res:=4;
					   atmos:=1;
					 end
			      else if orb<=outz then res:=0
						else res:=5;
		   if (atmos=2) and icy then begin
					       res:=3;
					       atmos:=1;
					     end;
		  end;
      if res=0 then
       begin
	  x:=de(10,1);
	  if ((x<5) and not gaia) or ((x<2) and gaia) then res:=14
	     else if (x<9) or gaia then res:=10
	       else res:=4;
	end;
      if diametre<1 then res:=7;
      if diametre=0 then res:=19;
  end;


function cube(x:real):real;
  begin
     cube:=x*x*x;
  end;

{ ---------- returns the world mass and gravity ---------------------}

procedure gravity_calcul(density:real;var diametre:real;
       var snowball:boolean;var mass:real;var gravity:real;icy:boolean);
   begin
     snowball:=false;
     if (density=0.1) and (diametre>39) then snowball:=true;
     if (density=0.2) and (diametre>30) then snowball:=true;
     if (density=0.3) and (diametre>26) then snowball:=true;
     if (density=0.4) and (diametre>23) then snowball:=true;
     if (density=0.5) and (diametre>21) then snowball:=true;
     if (density=0.6) and (diametre>20) then snowball:=true;
     if not icy then snowball:=false;
     if snowball then diametre:=diametre*de(10,1);
     gravity:=pi*density*diametre*169/6372;
     mass:=pi*density*cube(diametre/2)/796.5;
   end;


{ -------- returns the atmosphere type ------------}

procedure atmos_calcul(gravity,mass:real;var atmos:integer);
      var x:integer;
   begin
      x:=de(10,1);
      if gravity<0.1 then atmos:=6
	else
	   begin
	      if (gravity<=0.4) then
		if x>7 then atmos:=4
		  else if x>3 then atmos:=5
		    else atmos:=6;
	      if (gravity>0.4) and (gravity<=0.8) then
		 if x=10 then atmos:=2
		     else if ((x>5) and not gaia) or ((x>3) and gaia) then atmos:=3
			else if x>2 then atmos:=4
			   else if x=2 then atmos:=5
			      else atmos:=6;
	      if (gravity>0.8) and (gravity<=1.3) then
		 if x>7 then atmos:=2
		     else if (x>3) or gaia then atmos:=3
			else if x=3  then atmos:=4
			   else if x=2 then atmos:=5
			      else atmos:=6;
	      if (gravity>1.3) and (gravity<=2) then
		 if x>3 then atmos:=2
			else if x>1 then atmos:=3
			   else atmos:=4;
	      if (gravity>2) or (mass>2) then atmos:=2;
	 end;
	 
  end;

{ -------- returns the atmospheric pressure ----------}

function press_calcul(atmos:integer;gravity:real):real;
  var pressure:real;
  begin
	pressure:=gravity*(0.85+de(30,1)/100);
	case atmos of
	  1   : press_calcul:=pressure*100;
	  2   : press_calcul:=pressure*1.25;
	  3   : press_calcul:=pressure;
	  4   : press_calcul:=pressure*0.5;
	  5   : press_calcul:=pressure*0.25;
	  6   : press_calcul:=0;
	end;
  end;

{ -------- returns the water type and the surface coverage ---------- }

procedure water_calcul(inz,orb:real;var world,wat_type,hydro:integer);
	var res:integer;
    begin
	res:=1;
	hydro:=0;
	if world=2 then res:=2;
	if world=1 then res:=3;
	if (world=7) and (inz<orb) then res:=2;
	if world=14 then res:=6;
	if world=3 then res:=4;
	if world=5 then res:=6;
	if world=6 then res:=2;
	if world=10 then res:=5;
	wat_type:=res;
	if (res=2) or (res=4) then hydro:=1;
	if res=3 then hydro:=de(5,1)*10+de(10,1);
	if (res=5) or (res=6) then hydro:=(de(4,3)-3)*10+de(10,1);
	if res=5 then
	     if hydro<20 then world:=8
		else if hydro<50 then world:=9
		      else if hydro<90 then world:=10
			 else world:=12;

    end;

{ ----- returns the oxygen pressure based on water surface coverage ----- }

function oxygene_calcul(world,hydro:integer;gravity:real):real;
     var res:real;
	 x:integer;
   begin
     res:=0;
     x:=trunc(hydro/10);
     if (world>7) and (world<>13) then res:=oxygene_table[x+1]*gravity;
     if world=14 then res:=res/3;
     oxygene_calcul:=res/100;
   end;

{ ----- returns the atmospher's active gas(es) --------- }

function compos_atmos(atmos_typ,world:integer):integer;
    var res,x:integer;
	exotic:boolean;
   begin
     res:=1;
     exotic:=false;
     if (atmos_typ=4) or (world=4) or (world=7) then res:=3
	else if world=3 then res:=6
	   else if (world=1) or (world=5) then res:=7
	      else if world>7 then
		 begin
		   x:=de(10,1);
		   if ((x<>1) and (atmos_typ=3)) or ((x>2) and (atmos_typ=2))
		       then res:=2
			   else exotic:=true;
		 end;
     if exotic then
	  begin
	    x:=de(11,1);
	    if x<5 then res:=4
	      else if x<7 then res:=3
		 else if x=8 then res:=5
		    else if x=9 then res:=8
		      else if x=10 then res:=9
			 else res:=9
	  end;
     if (atmos_typ=6) then res:=1;
     compos_atmos:=res;
   end;

{ ------ returns the orbit period ------ }

function orbit_calcul(orbit,mass:real):longint;
      var res:real;
	  aux:double;
   begin
      res:=sqrt(cube(orbit)/mass);
      res:=res*365;
      orbit_calcul:=round(res);
   end;

{ ----- returns the rotation period ------- }

procedure rotation_calcul(orbit,mass,diametre,density,mass_stellar,age,
       eccentricity:real;period:longint;world:integer;var resonance:boolean;
       var res:longint);

      var base_angular_velocity,K,aux,change_velocity,angular_velocity:real;

      const j=1.46E-19;
	    change_earth=-1.25E-15;
   begin
      resonance:=false;
      if (world=3) then K:=0.24
	else K:=0.33;
      base_angular_velocity:=sqrt(2*j*mass*5.98E27/(K*sqr(diametre*5E7)));
      change_velocity:=change_earth*density*(diametre/12.75)*mass*sqr
	      (mass_stellar)*(1/(cube(orbit)*cube(orbit)));
      angular_velocity:=base_angular_velocity+change_velocity*age*1E9;
      aux:=6.28/(3600*angular_velocity);
      res:=trunc(aux);
      if (res<=2) then
	   begin
	     res:=period*24;
	     if (eccentricity>0.1) then res:=round((1-eccentricity)*res/(1+
		  eccentricity));
	     resonance:=true;
	   end;
      if (res>(period*24)) then
		   begin
		      res:=round(period*24);
		      resonance:=true;
		   end;

   end;

{ ----- returns the world eccentricity ---- }

function eccentricity_calcul:real;
      var x:integer;
	  res:real;
   begin
      x:=de(6,2);
      if x<8 then res:=0;
      if x=8 then res:=0.005;
      if x=9 then res:=0.010;
      if x=10 then res:=0.015;
      if x=11 then res:=0.020;
      if x=12 then
	   begin
	     x:=de(6,1);
	     if x=1 then res:=0.025;
	     if x=2 then res:=0.05;
	     if x=3 then res:=0.1;
	     if x=4 then res:=0.2;
	     if x=5 then res:=0.25;
	     if x=6 then res:=0.2+de(6,1)/10;
	   end;
      eccentricity_calcul:=res;
   end;

{ ----- returns the average surface temperature ------
    lux=effective luminosity of the star(s)
    green_effect=greenhouse effect
    energy_abs=energy absorption of the world
  ---------------------------------------------------- }

function temp_calcul(lux,orbit:real;atmos,hydro,
		      world:integer):integer;
   var res,green_effect,energy_abs:real;
   begin
	  if (atmos>4) then energy_abs:=0.8-random(50)/1000
	    else if (atmos>2)  then energy_abs:=0.8-random(190)/1000
	     else energy_abs:=0.7-random(200)/1000;
	  if (hydro<10) then energy_abs:=energy_abs+0.1;
	  green_effect:=1;
	  if (atmos<5) then green_effect:=1.05;
	  if (atmos=1) then green_effect:=1.15;
	  if (atmos=2) then green_effect:=1.1;
	  if (world=4) then green_effect:=1.15;
	  res:=sqrt(sqrt(lux)/orbit)*340*energy_abs*green_effect-273;
	  if (world=14) and (res>-15) then res:=-15;
	  if ((world=8) or (world=4)) and (res<40) then res:=40;
	  if (world=12) and (res<5) then res:=5;
	  if (world=11) and (res<20) then res:=20;
	  if (world=10) and (res<10) then res:=10;
	  temp_calcul:=round(res);
   end;

{ ---- returns the day and night temperature variation ----- }

procedure temp_var(var day,night:longint;lux,orbit:real;atmos:integer;
		   rot:longint;temp:integer);
      var rot_lux:real;
	  max_day,max_night:longint;
    begin
	rot_lux:=lux/sqrt(orbit);
	rot:=abs(rot);
	temp:=temp+273;
	day:=trunc(day_table[atmos]*rot_lux*rot/2);
	night:=trunc(night_table[atmos]*rot/2);
	max_day:=trunc(temp*day_max[atmos]*rot_lux);
	max_night:=trunc(temp*night_max[atmos]);
	if (day>max_day) then day:=max_day;
        if (day+temp)>2000 then day:=2000-temp;
	if (night>max_night) then night:=max_night;
    end;

{ ---- returns the number of satellites ---- }

function satellites_calcul(world:integer):integer;
       var res:integer;
    begin
	 res:=de(6,1)-3;
	 if (res<0) then res:=0;
	 if (world=3) then res:=de(6,2);
	 satellites_calcul:=res;
    end;

{ ---- returns the world diameter and density ---- }

procedure diametre_calcul(var icy:boolean;orbit,innerz,outerz:real;
	 var diametre:real;var density:real);
   var res:integer;
   begin
      icy:=false;
      if (de(6,1)>1) and (orbit>outerz) then
	  icy:=true;
      if not icy then
	  begin
	    if (not gaia) or (orbit>outerz) or (orbit<innerz) then diametre:=de(6,de(6,1)) else diametre:=de(8,1)+8;
	    if (not gaia) or (orbit>outerz) or (orbit<innerz) then density:=de(10,1)/10+0.3 else density:=de(6,1)/10+0.7;
	  end
      else
	  begin
	    res:=de(6,1);
	    density:=de(6,1)/10;
	    if res<4 then diametre:=res
		else if res=4 then diametre:=5
		  else if res=5 then  diametre:=6
			else diametre:=8;
	    diametre:=de(6,round(diametre));
	  end;
      diametre:=diametre+de(999,1)/1000;

    end;

{ ---- returns the axial tilt ---- }

function axial_tilt_calcul:integer;
   var aux:integer;
   begin
       aux:=de(6,2);
       if (aux<12) then axial_tilt_calcul:=de(6,2)-2+trunc(aux/2-1)*10
	   else  axial_tilt_calcul:=38+de(4,1)*10+de(6,2);
   end;

{ ---- returns the orbital radius of satellites given -----
        in planetary diameters of the parent planet
  ---------------------------------------------------------}

function moon_orbit(diametre:real):integer;
   var aux,factor:integer;
   begin
      aux:=de(10,1);
      case aux of
	 1..3 :factor:=1;
	 4..6 :factor:=2;
	 7..10:factor:=3;
      end;
      if diametre=0 then factor:=1;
      case factor of
	 1 :begin
	      aux:=de(10,1);
	      if (diametre>0.2) and (aux<3) then moon_orbit:=3
		else moon_orbit:=aux;
	    end;
	 2 :moon_orbit:=de(10,1)*5+10;
	 3 :moon_orbit:=de(10,1)*10+60;
      end;
  end;

{ ----------------------------------------
      retuns the mineral ressources 
       diametre=-1 asteroid belt
       diametre=0  ring
  ---------------------------------------- }

procedure mine_calcul (diametre,density:real;var mine:table_num);
var aux,a:integer;
    aux1 :real;
begin
  if diametre=0 then
	begin
	  diametre:=0.7;
	  density:=de(10,1)+0.3;
	end;
  if diametre=-1 then diametre:=5;
  for a:=1 to 5 do
     begin
        aux1:=diametre*density*5;
        if aux1>120 then aux1:=120;
        aux:=trunc((aux1)+de(mine_k[a],1)-60);
        mine[a]:=aux;
        if aux<1 then mine[a]:=1
           else if aux>100 then mine[a]:=100;
     end;
end;

{ -----------------------------------------
  returns the number of stars in the system,
  their spectral class,luminosity,mass,age, 
  and companion star orbit radii.
  ----------------------------------------- }

procedure star_creation(var luminosity,mass:table_2;var age:real;
    var class,type_spec:table_1;var star_nbr:shortint;var distance:real);
   var b,aux:integer;
       main_sequence_life:real;
   begin
	   star_nbr:=1;
	   if de(10,1)>4 then star_nbr:=2;
	   for b:=1 to star_nbr do
	    begin
	      aux:=de(100,1)+(b-1)*20;
              if not gaia then
                case aux of
	          1..5: class[b]:=1;
                  6..9: class[b]:=2;
		  10..20: class[b]:=3;
                  21..45: class[b]:=4;
                  46..70: class[b]:=5;
                  71..90: class[b]:=6;
                  else class[b]:=7;
                end;
              if gaia then
                 case aux of
                   1: class[b]:=1;
                   2..5: class[b]:=2;
                   6..20: class[b]:=3;
                   21..70: class[b]:=4;
                   71..90: class[b]:=5;
                   91..95: class[b]:=6;
                   else if b=1 then class[b]:=6 else class[b]:=7;
                 end;
	      if (star_nbr=2) and (class[1]>class[2]) then
		  class[2]:=class[2]+1;
	      type_spec[b]:=de(10,1)-1;
	      case class[b] of
	      1: begin
		  mass[b]:=14-0.3*type_spec[b];
		  luminosity[b]:=2200-type_spec[b]*160;
		 end;
	      2: begin
		  mass[b]:=6.3+0.31*type_spec[b];
		  luminosity[b]:=470+22*type_spec[b];
		 end;
	      3: begin
		  mass[b]:=1.7-0.07*type_spec[b];
		  luminosity[b]:=8.1-type_spec[b]*0.7;
		 end;
	      4: begin
		  mass[b]:=1.04-0.01*type_spec[b];
		  luminosity[b]:=1.21-type_spec[b]*0.08;
		 end;
	      5: begin
		  mass[b]:=0.82-0.034*type_spec[b];
		  luminosity[b]:=0.42-type_spec[b]*0.038;
		 end;
	      6: begin
		  mass[b]:=0.48-0.027*type_spec[b];
		  luminosity[b]:=0.04-0.0039*type_spec[b];
		 end;
	      7: begin
		  mass[b]:=0.8-type_spec[b]*0.05;
		  luminosity[b]:=0.001-type_spec[b]*0.0001;
		 end;
	      
	      end;
	 end;


      main_sequence_life:=1000*(mass[1]/luminosity[1]);
      if (main_sequence_life>=6) then age:=random(500)+100
	 else age:=random(round(main_sequence_life)-100)+100;
      age:=age/100;
      if (de(6,1)=1) or (class[1]<3) then distance:=de(950,1)/10+5
	 else distance:=de(90,1)/10+1;
      if gaia and (distance<5) then distance:=5;
   end;

{ --- returns the number of planets around each star ----
      astral_orbit<0 => asteroid belt                    }

procedure orbit_creation(var astral_orbit:table_real;var planet_nbr:integer;
	      stellar_type:integer;mass,companion_dist,lux:real);
  var a,aux,planet_tmp:integer;
      orbit_tmp:real;
    begin
       astral_orbit[1]:=de(10,1)/10;
       if astral_orbit[1]<(sqrt(lux)/100) then      { untenable orbits }
               astral_orbit[1]:=sqrt(lux)/100+0.1;
       orbit_tmp:=astral_orbit[1];
       case stellar_type of
	  1: planet_nbr:=0;
	  2: planet_nbr:=0;
	  3: if not gaia then planet_nbr:=de(10,1) else planet_nbr:=de(8,1)+2;
	  4: if not gaia then planet_nbr:=de(6,3) else planet_nbr:=de(4,4)+2;
	  5: planet_nbr:=de(6,2);
	  6: planet_nbr:=de(6,1);
	  7: planet_nbr:=0;
      end;
      planet_tmp:=planet_nbr;
      for a:=2 to planet_tmp do
	 begin
	  aux:=de(10,1);
	  if (aux=1) then
	       begin
		  if (de(6,1)>2) then
			  begin
			    astral_orbit[a]:=-orbit_tmp*(de(9,1)/10+1.2);
			    orbit_tmp:=abs(astral_orbit[a]);
			  end
		    else  begin
			    planet_nbr:=a-1;
			    a:=planet_tmp;
			  end
	       end
	     else  begin
		      astral_orbit[a]:=orbit_tmp*(aux/10+1.2);
		      orbit_tmp:=astral_orbit[a];
		   end;

	 if (orbit_tmp>40*mass) or (orbit_tmp>companion_dist/3) then
				begin
				  planet_nbr:=a-1;
				  a:=planet_tmp;
				end;
	 end;
    end;

{ ------- returns the unusual characteristics ------
  life_chance>49 semi-intelligent lifeforms
  life_chance>74 intelligent lifeforms }

procedure unusual_calcul(atmos_type,world_type,satellites,water_type,
  hydrography,axial_tilt,atmos:integer;mine:table_num;rotation_period:longint;icy_core,
  resonance:boolean;var f:text;eccentricity,temperature,gravity:real;
  var unusual:table_bool);
var life_chance,aux:integer;
    count:boolean;
    water_vapor:real;
begin
    for aux:=1 to max_unusual do unusual[aux]:=false;
    life_chance:=0;
    if  (not icy_core) and (satellites>0) and (de(75,1)=1) then
         begin
            unusual[1]:=true;
            if (atmos<5) and (de(10,2)<7) then unusual[2]:=true;
            life_chance:=-5;
            if de(10,2)<5 then unusual[12]:=true;
         end;
    if  (atmos<5) and (de(75,1)=1) then
         begin
	    unusual[2]:=true;
	    life_chance:=life_chance-5;
         end;
    if de(75,1)=1 then
         begin
	    unusual[3]:=true;
	    life_chance:=life_chance-5;
	 end;
    if de(50,1)=1 then unusual[9]:=true;
    if ((atmos>4) and (de(10,1)=1)) or ((de(35,1)=1) and (not icy_core)) or
       (de(50,1)=1) then
	 begin
            unusual[4]:=true;
            life_chance:=life_chance-15;
	 end;
    if (atmos_type<5) and ((de(30,1)=1) or ((de(6,1)=1) and (axial_tilt<5)))
        then  begin
                unusual[5]:=true;
                life_chance:=life_chance-5;
              end;
    if (atmos_type<5) and (de(50,1)=1) then
         begin
	    unusual[6]:=true;
	    life_chance:=life_chance-5;
	 end;
    if de(150,1)=1 then
         begin
	    unusual[7]:=true;
	    life_chance:=life_chance-20;
	 end;
    if (not icy_core) and (world_type <>12) and (de(50,1)=1) then
        unusual[8]:=true;
    if (de(50,1)=1) and (atmos<5) then
        begin
          unusual[10]:=true;
          life_chance:=life_chance-10;
        end;
    if (atmos_type<4) and (de(6,1)=1) then unusual[14]:=true;
    if (hydrography>50) and (water_type=5) and (satellites>0) and
           (de(6,1)>4) then
		  begin
		    unusual[16]:=true;
		    life_chance:=life_chance-5;
		  end;
    if (axial_tilt>50) then
	          begin
		     life_chance:=life_chance-15;
		     unusual[18]:=true;
		     if (de(6,1)<4) then unusual[4]:=true;
	           end;
    if (axial_tilt<5) then
	          begin
		      unusual[15]:=true;
		      life_chance:=life_chance+10;
		  end;
    if ((rotation_period<15) and (de(10,1)=1)) or (de(30,1)=1) then
                  begin
		      life_chance:=life_chance-10;
		      unusual[13]:=true;
		  end;
    if resonance then unusual[17]:=true;
    if (eccentricity>0.25) then
		  begin
	  	      life_chance:=life_chance-5;
		      if not icy_core then unusual[1]:=true;
		      if (de(10,2)<7) and (atmos_type<4) then unusual[2]:=true;
		      unusual[11]:=true;
		  end;
     if (water_type=5) then
       water_vapor:=exp(0.698*(temperature-15))*hydrography/(0.007*gravity);
     if (water_vapor>30000) and (water_type=5) then unusual[21]:=true;
     if (water_vapor<0.2) and (water_type=5) then unusual[22]:=true;
     case world_type of
		   10,11,12 : life_chance:=life_chance+25;
		   8,9      : life_chance:=life_chance+5;
		   13       : life_chance:=life_chance-45;
		   14       : life_chance:=life_chance-45;
		   5      : life_chance:=life_chance-55;
		   else life_chance:=life_chance-200;
     end;
     aux:=de(100,1)+life_chance;
     if aux>74 then unusual[19]:=true
           else if aux>49 then unusual[20]:=true;
     writeln(f,'Unusual Characteristics:');
     count:=false;
     for aux:=1 to max_unusual do
         begin
           if unusual[aux] then
              begin
                 writeln(f,'  -',unusual_genre[aux]);
                 count:=true;
              end;
          end;
      if not count then writeln(f,'  -None');

end;


procedure emptystr(var f:text;a:integer);
var aux:integer;
begin
for aux:=1 to a do write(f,' ');
end;

{ ----------------- Gives the infos on the moons -------------------}

procedure moon_creation (var f:text;diametre:real;satellites:integer;
    orbit_radius,innerzone,outerzone:real);
var aux,atmos_type,world_type,water_type,hydrography:integer;
    mine_ress:table_num;
    satellite_orbit:integer;
    snowball,icy_core:boolean;
    moon_diameter,density,mass,pressure,gravity:real;
begin
   write(f,'   Diameter    Orbit     Type          Gravity  ');
   writeln(f,'Atmos       Mine');
   write(f,'      Km      Kmx1000                     xG    ');
   writeln(f,'Type');
   for aux:=1 to satellites do
       begin
         moon_diameter:=de(10,1)-4;
	 if moon_diameter<0 then moon_diameter:=0
	    else moon_diameter:=moon_diameter+de(999,1)/1000;
	 while (moon_diameter>diametre) do
	 moon_diameter:=round(moon_diameter/2);
	 if moon_diameter=0 then write(f,'       NA')
	 else write(f,'   ',round(moon_diameter*1000):6);
         emptystr(f,4);
	 if (de(6,1)>1) and (orbit_radius>outerzone) then
                             icy_core:=true
	    else icy_core:=false;
	 if icy_core then density:=de(6,1)/10
	 else density:=de(10,1)/10+0.3;
	 gravity_calcul(density,moon_diameter,snowball,mass,
                             gravity,icy_core);
	 atmos_calcul(gravity,mass,atmos_type);
	 world_calcul(atmos_type,world_type,innerzone,
               outerzone,orbit_radius,moon_diameter,icy_core,snowball);
	 water_calcul(innerzone,orbit_radius,world_type,
                             water_type,hydrography);
	 satellite_orbit:=moon_orbit(moon_diameter);
         pressure:=press_calcul(atmos_type,gravity);
	 mine_calcul(moon_diameter,density,mine_ress);

	 write(f,'  ',round(satellite_orbit*diametre):5);
         emptystr(f,2);
         write(f,'   ',world_genre[world_type]);
         write(f,'   ',gravity:0:2);
         write(f,'   ',atmos_genre[atmos_type]);
         write(f,'   ',mine_ress[1],'/',mine_ress[2],'/',mine_ress[3]);
         writeln(f,'/',mine_ress[4],'/',mine_ress[5]);

      end;
end;


var sys1: star_record;
    sys2: planet_record;
    pfile: file of planet_record;
    res:integer;
    new_file: boolean;
    aux,a,b:integer;
    code:integer;
    innerzone,outerzone,lux:real;
    commandline,string1,string2,auxstr,finstr,extestr,filename:string;
    paramnbr:table_index;
    commstr:table;
    f:text;
    index,id_count:word;
const
    earth_change_velocity=-1.3E-15;
begin
 
 initialisation;
 id_count:=0;
 new_file:=true;
 gaia:=false;extestr:='log';
 for index:=1 to paramcount do
       commstr[index]:=paramstr(index);
 for index:=1 to paramcount do
       begin
	 auxstr:=copy(commstr[index],1,2);
	 finstr:=commstr[index];
	 delete(finstr,1,2);
	 if (auxstr='/G') or (auxstr='/g')
	     then gaia:=true;
	 if (auxstr='/X') or (auxstr='/x')
	     then extestr:=copy(finstr,1,3);
         if (auxstr='/O') or (auxstr='/o')
             then new_file:=false;
       end;
 
 if extestr='log' then filename:='star.log'
     else filename:=concat('star.',extestr);
 if gaia then writeln('Gaia parameter On');
 randomize;
 assign(f,filename);
 rewrite(f);
 star_creation(sys1.luminosity,sys1.mass_star,sys1.age,
               sys1.class,sys1.type_spec,sys1.star_nbr,
               sys1.companion_dist);
 if sys1.star_nbr=2 then
	begin
	   writeln(f,'Binary system');
	   writeln(f,'    Companion star orbit radii: ',sys1.companion_dist:0:1,
	      ' A.U');
	   writeln(f);
	end;
 for b:=1 to sys1.star_nbr do
     begin
       if sys1.star_nbr=2 then writeln(f,class_spec[7+b])
       else writeln(f,'Stellar characteristics:');
       write(f,'    Luminosity    : ');
       if sys1.luminosity[b]<0.001 then writeln(f,sys1.luminosity[b]:0:4)
	  else writeln(f,sys1.luminosity[b]:0:3);
       writeln(f,'    Star Mass     : ',sys1.mass_star[b]:0:3);
       write(f,'    Spectral class: ',class_spec[sys1.class[b]]);
       if sys1.class[b]<7 then write(f,sys1.type_spec[b]);
       if (sys1.class[b]<7) and (sys1.class[b]<>2) then writeln(f,' V')
       else if (sys1.class[b]=7) then writeln(f,' VII')
	    else writeln(f,' III');
       writeln(f,'    Age           : ',sys1.age:0:2, ' billions years');

       if b=1 then lux:=sys1.luminosity[2]
		       else lux:=sys1.luminosity[1];
       if sys1.star_nbr=1 then lux:=sys1.luminosity[1] else
          begin
              lux:=sys1.luminosity[b]+lux/(sqrt(sys1.companion_dist));
          end;
       innerzone:=0.82*sqrt(lux);
       outerzone:=1.2*sqrt(lux);
       orbit_creation(sys1.astral_orbit,sys1.planet_nbr[b],sys1.class[b],
                      sys1.mass_star[b],sys1.companion_dist,lux);
       writeln(f);
       writeln(f,'Planets present at:');
       for a:=1 to sys1.planet_nbr[b] do
	   writeln(f,a:2,'      ',abs(sys1.astral_orbit[a]):0:1,'  A.U.');
       if sys1.planet_nbr[b]=0 then writeln(f,' no planets');
       writeln(f);

       for a:=1 to sys1.planet_nbr[b] do
	   begin
	     sys2.orbit_radius:=sys1.astral_orbit[a];
	     writeln(f);
	     writeln(f,'Planet ',a:2);
	     if (sys2.orbit_radius<0) then    { asteroid belts }
		begin
		  sys2.orbit_radius:=abs(sys1.astral_orbit[a]);
		  aux:=de(6,2)-1;
		  if (sys2.orbit_radius<1.5) then aux:=aux-3
		  else if (sys2.orbit_radius<20) then aux:=aux-1;
		  if (aux<2) then aux:=2;
                  sys2.ast_width:=aux;
		  writeln(f,'Asteroid belt: ',belt_width[aux]:0:2,
		    ' A.U. width');
		  aux:=de(6,2);
		  if sys2.orbit_radius <= innerzone then aux:=aux-4;
		  if sys2.orbit_radius >= outerzone then aux:=aux+2;
		  if aux<5 then sys2.world_type:=15
		  else if aux<8 then sys2.world_type:=16
		       else if aux<12 then sys2.world_type:=17
			    else sys2.world_type:=18;
		  case sys2.world_type of
		      15: sys2.density:=de(3,1)/10+1;
		      16: sys2.density:=de(3,1)/10+0.6;
		      17: sys2.density:=de(3,1)/10+0.2;
		      18: sys2.density:=de(6,1)/10;
		  end;
		  mine_calcul(-1,sys2.density,sys2.mine_ress);
		  writeln(f,'Predominate asteroids :',
                          world_genre[sys2.world_type]);
		  writeln(f,'Mineral ressources    :');
                  writeln(f,'  -Metal ore      : ',sys2.mine_ress[1]);
                  writeln(f,'  -Radioactive ore: ',sys2.mine_ress[2]);
                  writeln(f,'  -Precious metal : ',sys2.mine_ress[3]);
                  writeln(f,'  -Raw crystals   : ',sys2.mine_ress[4]);
                  writeln(f,'  -Precious gems  : ',sys2.mine_ress[5]);
                  sys2.Id:=id_count;
                  id_count:=id_count+1;
                end
	     else begin
		    
		    diametre_calcul(sys2.icy_core,sys2.orbit_radius,innerzone,
                       outerzone,sys2.diametre,sys2.density);
		    gravity_calcul(sys2.density,sys2.diametre,sys2.snowball,
                       sys2.mass,sys2.gravity,sys2.icy_core);
		    atmos_calcul(sys2.gravity,sys2.mass,sys2.atmos_type);
		    world_calcul(sys2.atmos_type,sys2.world_type,innerzone,
                       outerzone,sys2.orbit_radius,sys2.diametre,sys2.icy_core,
                       sys2.snowball);
		    water_calcul(innerzone,sys2.orbit_radius,sys2.world_type,
                       sys2.water_type,sys2.hydrography);
		    sys2.oxygene_taux:=oxygene_calcul(sys2.world_type,
                       sys2.hydrography,sys2.gravity);
		    sys2.atmos:=compos_atmos(sys2.atmos_type,sys2.world_type);
		    sys2.pressure:=press_calcul(sys2.atmos_type,sys2.gravity);
		    sys2.eccentricity:=eccentricity_calcul;
		    sys2.orbit_period:=orbit_calcul(sys2.orbit_radius,sys1.mass_star[b]);
		    rotation_calcul(sys2.orbit_radius,sys1.mass_star[b],sys2.diametre,
		      sys2.density,sys1.mass_star[b],sys1.age,sys2.eccentricity,
                      sys2.orbit_period,sys2.world_type,sys2.resonance,
                      sys2.rotation_period);
		    mine_calcul(sys2.diametre,sys2.density,sys2.mine_ress);
		    sys2.escape_velocity:=sys2.gravity*11.2;
		    sys2.axial_tilt:=axial_tilt_calcul;

		    writeln(f,'Orbit radius      : ',sys2.orbit_radius:0:1,' A.U.');
		    writeln(f,'Type              : ',world_genre[sys2.world_type]);
		    writeln(f,'Density           : ',sys2.density:0:1,'  Earth density');
		    writeln(f,'Diameter          : ',round(sys2.diametre*1000),' km');
		    writeln(f,'Gravity           : ',sys2.gravity:0:2,' Earth gees');
		    writeln(f,'Mass              : ',sys2.mass:0:3,'  Earth masses');
		    writeln(f,'Escape velocity   : ',sys2.escape_velocity:0:2,' km/s');
		    writeln(f,'Atmosphere        : ',atmos_genre[sys2.atmos_type]);
		    writeln(f,'  -Atmospheric pressure    : ',sys2.pressure:0:3,' atm');
		    writeln(f,'  -Oxygen                  : ',sys2.oxygene_taux:0:3,' atm');
		    writeln(f,'  -Atmospheric composition : ',atmos_comp[sys2.atmos]);
		    if sys2.world_type<>3 then
                          begin
                             writeln(f,'Mineral ressources    :');
                             writeln(f,'  -Metal ore      : ',sys2.mine_ress[1]);
                             writeln(f,'  -Radioactive ore: ',sys2.mine_ress[2]);
                             writeln(f,'  -Precious metal : ',sys2.mine_ress[3]);
                             writeln(f,'  -Raw crystals   : ',sys2.mine_ress[4]);
                             writeln(f,'  -Precious gems  : ',sys2.mine_ress[5]);
                          end;
		    write(f,'Water             : ',water_genre[sys2.water_type]);
		    if (sys2.atmos>2) and (sys2.hydrography>0) then
                        begin
                          if de(6,2)>10 then sys2.water_tainted:=true
                             else sys2.water_tainted:=false;
                          if sys2.water_tainted then
                              write (f,' of tainted liquid water')
			  else write (f,' of atmosphere related chemical mix');
                        end;
		    writeln(f);
		    writeln(f,'  %Water          : ',sys2.hydrography);
		    writeln(f,'Orbital  period   : ',sys2.orbit_period,' days');
		    writeln(f,'Rotation period   : ',sys2.rotation_period,' hours');
		    writeln(f,'Eccentricity      : ',sys2.eccentricity:0:3);
		    writeln(f,'Axial tilt        : ',sys2.axial_tilt:2,' ');
		    sys2.temp_avg:=temp_calcul(lux,sys2.orbit_radius,sys2.atmos_type,
		       sys2.hydrography,sys2.world_type);

		    writeln(f,'Temperature:');
		    writeln(f,'  -Average Temperature      : ',sys2.temp_avg,' C');
		    writeln(f,'  -Effects of eccentricity  : +/-',
		      trunc(sys2.eccentricity*30),' C');

		    writeln(f,'  -Maximum increase         : +',
			 sys2.axial_tilt*0.6:0:0,' C');
		    writeln(f,'  -Maximum decrease         : -',
			 sys2.axial_tilt:0,' C');
		    temp_var(sys2.day_temp,sys2.night_temp,lux,sys2.orbit_radius,
                         sys2.atmos_type,sys2.rotation_period,sys2.temp_avg);
		    writeln(f,'  -Maximum day increase     : +',sys2.day_temp,' C');
		    writeln(f,'  -Maximum night decrease   : -',sys2.night_temp,' C');
		    sys2.satellites:=satellites_calcul(sys2.world_type);
                    unusual_calcul(sys2.atmos_type,sys2.world_type,sys2.satellites,
                       sys2.water_type,sys2.hydrography,sys2.axial_tilt,
                       sys2.atmos,sys2.mine_ress,sys2.rotation_period,
                       sys2.icy_core,sys2.resonance,f,sys2.eccentricity,
                       sys2.temp_avg,sys2.gravity,sys2.unusual);
		    writeln(f,'Satellites        : ',sys2.satellites);
                    if sys2.satellites>0 then moon_creation(f,sys2.diametre,sys2.satellites,
                    sys2.orbit_radius,innerzone,outerzone);

                    Str(sys2.temp_avg,string1);
                    Str(sys2.gravity,string2);
                    commandline:='/T'+string1+' '+'/G'+string2+' '+'/X'+extestr;
                    if  sys2.unusual[19] then
                      begin
                       close(f);
                       SwapVectors;
                       Exec('alien.exe',commandline);
                       SwapVectors;
                       append(f);
                      end;
                    sys2.Id:=id_count;
                    id_count:=id_count+1;
                   end;
	writeln(f);
	writeln(f);
   end;
   writeln(f);
   writeln(f);
   end;
 writeln('Thanks to using Star v1.4');
close(f);
end.
